---------------------------------------------------------------------------
--Animation Module
---------------------------------------------------------------------------
local Public, Private = {}, {}
Animation = Public

function Public.load(file)
    local animation = {}
    local description, err = dofile(file)
    if not description then return nil, err end
    print("Animation File: " .. file)
    for i, v in description do
        local frames = {}
        local num = getn(v)
        for j = 1, num do
            tinsert(frames, Scene.load("scenes/" .. v[j]))
            write(_STDERR, "Rendering ", i, ": ", j*100/num, "%\r") 
        end
        write("Rendering ", i, ": 100%\n") 
        animation[i] = frames 
    end
    return animation
end
