local Local, Private, Public = {}, {}, {}
Local.frames = 100
ProbeAnim = Public

function Private.renderFoot()
    local trd = 1/3
    local fth = 0.5/3
    gl_begin(GL_QUADS)
        gl_normal(0, 0, -1)
        gl_vertex(0, -fth, 0)
        gl_vertex(1, -fth, 0)
        gl_vertex(1, fth, 0)
        gl_vertex(0, fth, 0)
    gl_end()
    gl_begin(GL_QUADS)
        gl_normal(-1, 0, 0)
        gl_vertex(0, fth, 0)
        gl_vertex(0, -fth, 0)
        gl_vertex(0, -fth, trd)
        gl_vertex(0, fth, trd)
    gl_end()
    gl_begin(GL_QUADS)
        local n = sqrt(10)
        gl_normal(3/n, 0, 1/n)
        gl_vertex(0, fth, trd)
        gl_vertex(0, -fth, trd)
        gl_vertex(1, -fth, 0)
        gl_vertex(1, fth, 0)
    gl_end()
    gl_begin(GL_TRIANGLES)
        gl_normal(0, -fth, 0)
        gl_vertex(0, -fth, 0)
        gl_vertex(1, -fth, 0)
        gl_vertex(0, -fth, trd)
    gl_end()
    gl_begin(GL_TRIANGLES)
        gl_normal(0, fth, 0)
        gl_vertex(0, fth, 0)
        gl_vertex(1, fth, 0)
        gl_vertex(0, fth, trd)
    gl_end()
end

function Private.renderAntena()
    gl_begin(GL_QUADS)
        gl_normal(0, -1, 0)
        gl_vertex(-0.1, -0.1, 0)
        gl_vertex(0.1, -0.1, 0)
        gl_vertex(0.1, -0.1, 2)
        gl_vertex(-0.1, -0.1, 2)
    gl_end()
    gl_begin(GL_QUADS)
        gl_normal(0, 1, 0)
        gl_vertex(-0.1, 0.1, 0)
        gl_vertex(0.1, 0.1, 0)
        gl_vertex(0.1, 0.1, 2)
        gl_vertex(-0.1, 0.1, 2)
    gl_end()
    gl_begin(GL_QUADS)
        gl_normal(-1, 0, 0)
        gl_vertex(-0.1, -0.1, 0)
        gl_vertex(-0.1, 0.1, 0)
        gl_vertex(-0.1, 0.1, 2)
        gl_vertex(-0.1, -0.1, 2)
    gl_end()
    gl_begin(GL_QUADS)
        gl_normal(1, 0, 0)
        gl_vertex(0.1, -0.1, 0)
        gl_vertex(0.1, 0.1, 0)
        gl_vertex(0.1, 0.1, 2)
        gl_vertex(0.1, -0.1, 2)
    gl_end()
    gl_begin(GL_QUADS)
        gl_normal(0, 0, 1)
        gl_vertex(-0.1, -0.1, 2)
        gl_vertex(0.1, -0.1, 2)
        gl_vertex(0.1, 0.1, 2)
        gl_vertex(-0.1, 0.1, 2)
    gl_end()
end

function Private.drawFoot(angle)
    gl_pushmatrix()
        gl_translate(1/3, 0, 0)
        gl_rotate(angle, 0, -1, 0)
        gl_calllist(Local.flist)
    gl_popmatrix()
end

function Private.drawFeet(angle)
    Private.drawFoot(angle)
    gl_pushmatrix()
        gl_rotate(90, 0, 0, 1)
        Private.drawFoot(angle)
    gl_popmatrix()
    gl_pushmatrix()
        gl_rotate(180, 0, 0, 1)
        Private.drawFoot(angle)
    gl_popmatrix()
    gl_pushmatrix()
        gl_rotate(270, 0, 0, 1)
        Private.drawFoot(angle)
    gl_popmatrix()
end

function Public.init()
    gl_deletelists(Local.flist, 1)
    gl_deletelists(Local.alist, 1)
    Local.frame = 1
    Local.flist = gl_genlists(1)
    gl_newlist(Local.flist, GL_COMPILE)
        Private.renderFoot()
    gl_endlist()
    Local.alist = gl_genlists(1)
    gl_newlist(Local.alist, GL_COMPILE)
        Private.renderAntena()
    gl_endlist()
end

function Public.draw(frame, ax, ay)
    frame = tonumber(frame)
    local frames = Local.frames/4
gl_pushmatrix()
gl_scale(0.25, 0.25, 0.25)
    if frame <= frames then
        gl_pushmatrix()
            gl_translate(0, 0, 1*(frame-1)/(frames-1)-1)
            Private.drawFeet(100)
        gl_popmatrix()
    elseif frame <= 2*frames then
        Private.drawFeet(-110*(frame-frames)/(frames-1)+100)
    elseif frame <= 3*frames then
        Private.drawFeet(-10)
        gl_pushmatrix()
            gl_translate(0, 0, (7/3)*(frame-2*frames)/(frames-1)-2)
            gl_calllist(Local.alist)
        gl_popmatrix()
    elseif frame <= 4*frames then
        Private.drawFeet(-10)
        gl_pushmatrix()
            gl_translate(0, 0, 1/3)
            gl_rotate(Quat.torotation(Quat.mul(
                Quat.fromrotation(ax*(frame-3*frames)/(frames-1), -1, 0, 0),
                Quat.fromrotation(ay*(frame-3*frames)/(frames-1), 0, -1, 0))))
            gl_calllist(Local.alist)
        gl_popmatrix()
    else
        Private.drawFeet(-10)
        gl_pushmatrix()
            gl_translate(0, 0, 1/3)
            gl_rotate(Quat.torotation(Quat.mul(
                Quat.fromrotation(ax, -1, 0, 0),
                Quat.fromrotation(ay, 0, -1, 0))))
            gl_calllist(Local.alist)
        gl_popmatrix()
    end 
gl_popmatrix()
end
