---------------------------------------------------------------------------
--Probe Module
---------------------------------------------------------------------------
local Private, Public, Local = {}, {}, {}
local eventtable = eventtable
Probe = Public

Private.eventtable = { index = {} }

function Private.eventtable.index.draw(self)
    local ax, ay = self.ax, self.ay
    local vect = self.animation
    local frame = self.frame
    local model = vect[frame]
    gl_pushmatrix()
    gl_rotate(Quat.torotation(Quat.mul(
        Quat.fromrotation(ax, 1, 0, 0),
        Quat.fromrotation(ay, 0, 1, 0))))
    gl_scale(model.factor, model.factor, model.factor)
    gl_translate(-model.xc, -model.yc, -model.zc)
    model:draw()
    gl_popmatrix()
end

function Private.eventtable.index.nextFrame(self)
    local frame = self.frame
    if frame >= getn(self.animation) then frame = 1
    else frame = frame + 1 end
    self.frame = frame
end

function Private.eventtable.index.setAnimation(self, vect)
    if vect ~= self.animation then 
        self.frame = 1
        self.animation = vect 
    end
end 

function Public.create(x, y, team, pressure, animation, ax, ay)
    local table = {
        x = x,
        y = y,
        team = team,
        frame = 1,
        pressure = pressure,
        animation = animation,
        ax = ax or 0,
        ay = ay or 0
    }
    eventtable(table, Private.eventtable)
    return table 
end
