---------------------------------------------------------------------------
--Score Module
---------------------------------------------------------------------------
local Local, Public = {}, {}
Score = Public

Local.maxscore = 20000

function Public.draw(teams)
    local x = -1
    local dy = 1/50
    for i = 1, getn(teams) do
        team = teams[i]
        local score = team.score
        local color = team.color
        if score > Local.maxscore then Local.maxscore = score end
        local y = ((i-1) / 25) - 1
        local dx = teams[i].score / (Local.maxscore / 2)
        gl_matrixmode(GL_PROJECTION)
        gl_pushmatrix()
        gl_loadidentity()
        gl_ortho(-1.2, 1.2, -1.2, 1.2, -1, 1)
        gl_matrixmode(GL_MODELVIEW)
        gl_pushmatrix()
        gl_loadidentity()
        gl_blendfunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA)
        gl_enable(GL_BLEND)
        gl_material(GL_FRONT, GL_SPECULAR, 0.1, 0.1, 0.1, 1.0)
        gl_enable(GL_COLOR_MATERIAL)
        gl_disable(GL_DEPTH_TEST)
        gl_disable(GL_LIGHTING)
        gl_color(color.r, color.g, color.b, 0.3)
        gl_begin(GL_QUADS)
            gl_normal(0, 0, 1)
            gl_vertex(x, y, 0)
            gl_vertex(x + dx, y, 0)
            gl_vertex(x + dx, y + dy, 0)
            gl_vertex(x, y + dy, 0)
        gl_end()
        gl_color(color.r, color.g, color.b, 0.5)
        gl_begin(GL_LINES)
            gl_normal(0, 0, 1)
            gl_vertex(x, y, 0)
            gl_vertex(x + dx, y, 0)
            gl_vertex(x + dx, y, 0)
            gl_vertex(x + dx, y + dy, 0)
            gl_vertex(x + dx, y + dy, 0)
            gl_vertex(x, y + dy, 0)
            gl_vertex(x, y + dy, 0)
            gl_vertex(x, y, 0)
        gl_end()
        gl_disable(GL_BLEND)
        gl_disable(GL_COLOR_MATERIAL)
        gl_enable(GL_DEPTH_TEST)
        gl_enable(GL_LIGHTING)
        gl_popmatrix()
        gl_matrixmode(GL_PROJECTION)
        gl_popmatrix()
        gl_matrixmode(GL_MODELVIEW)
    end
end
