local Private, Public = {}, {}
privRobot = Public

Private.eventtable = { index = {} }

function Private.eventtable.index.nextFrame(self)
    local frame = self.frame
    if frame >= getn(self.animation) then frame = 1
    else frame = frame + 1 end
    self.frame = frame
end

function Private.eventtable.index.putMsg(self, tipo, str)
    if getn(self.messages) >= 5 then
        self:getMsg()
    end 
    if not str then 
        str = tipo 
        tipo = "default"
    end
    tinsert(self.messages, {tipo = tipo, msg = str})
end  

function Private.eventtable.index.getMsg(self)
    local ret = self.messages[1]
    local n = getn(self.messages)
    for i = 1, n - 1 do
        self.messages[i] = self.messages[i+1]
    end 
    self.messages[n] = nil
    self.messages.n = self.messages.n - 1
    if self.messages.n < 1 then self.messages.n = 0 end
    return ret
end   

function Public.create(x, y, vx, vy, team, animation)
    local p = {
        x = x,
        y = y,
        x0 = x,
        y0 = y,
        angle0 = atan2(vy, vx),
        vx = vx,
        vy = vy,
        animation = animation,
        frame = 1,
        team = team,
        messages = { n = 0 }
    }
    eventtable(p, Private.eventtable)
    return p
end
